<?php
//$Id: placemaker.inc,v 1.1 2010/03/05 00:03:14 alarcombe Exp $

/**
 * Send and parse a simple placemaker request.
 */
function _placemaker_request_simple($content, $options) {
 
  $options['autodisambiguate'] = TRUE;
  $options['output'] = 'xml';

  $response = _placemaker_make_request($content, $options);

  $xml = simplexml_load_string($response);

  $results = array();

  foreach ($xml->document->placeDetails as $place_detail) {

    $results[] = array(  'woeid' => (string)$place_detail->place->woeId,
              'name' => (string)$place_detail->place->name,
              'type' => (string)$place_detail->place->type,
              'lat' => (string)$xml->document->placeDetails->place->centroid->latitude,
              'lon' => (string)$xml->document->placeDetails->place->centroid->longitude,
              'confidence' => (string)$place_detail->confidence,
     );
  
  }

  return $results;
}

/**
 * Send placemaker request
 */
function _placemaker_request_full($content, $options) {
  $response = _placemaker_make_request($content, $options);
  return $reponse;
}

/**
 * Make a placemaker request.
 */
function _placemaker_make_request($content, $options) {
  $placemaker_settings = variable_get('placemaker', '');
  $endpoint = 'http://wherein.yahooapis.com/v1/document';
  
  $post = 'appid=' . $placemaker_settings['appid'];

  if ($content['content']) {
    $post .= '&documentContent=' . $content['content'];
  }
  if ($content['title']) {
    $post .= '&documentTitle=' . $content['title'];
  }
  if ($content['url']) {
    $post .= '&documentURL=' . $content['url'];
  }
  if ($options['output']) {
    $post .= '&outputType=' . $options['output'];
  }
  if ($options['autodisambiguate'] == FALSE) {
    $post .= '&autoDisambiguate=false';
  }
  if ($options['woeid']) {
    $post .= '&focusWoeid=' . $options['woeid'];
  }
  if ($options['language']) {
    $post .= '&inputLanguage=' . $options['woeid'];
  }
  $post .= '&documentType=' . $content['type'];

  $ch = curl_init($endpoint);
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);  
  
  $results = curl_exec($ch);
  
  // @TODO: Error handling
  
  return $results;  
}